<!--
  ~ (c) Copyright 2024 Swiss Post Ltd.
  -->

<h1 class="h2 fw-medium mb-3">
	{{ 'preConfigure.title' | translate }}
</h1>
<p class="mb-4">
	{{ 'preConfigure.instruction' | translate }}
</p>

<sdm-page-actions #pageActionsComponent [forceError]="loadingSummaryError" [forceInProgress]="loadingSummary">
	<!-- Loading summary in progress -->
	<ng-container *ngIf="!configurationSummary" onProgress>
		<div class="spinner">
			<span aria-hidden="true" class="spinner-border"></span>
			<span
					class="visually-hidden"
					role="status"
			>{{ 'common.loading' | translate }}</span>
		</div>
		<p>
			{{ 'preConfigure.pageActions.loadingSummary' | translate }}
		</p>
	</ng-container>

	<!-- Validate contest summary and start pre-configuration -->
	<ng-container *ngIf="configurationSummary" onReady>
		<i aria-hidden="true" class="bi bi-pen"></i>
		<p>
			{{ 'preConfigure.pageActions.instruction' | translate }}
		</p>
		<button
				(click)="reload()"
				[disabled]="isContestConfirmed"
				class="btn btn-link"
				type="button"
		>
			<i aria-hidden="true" class="bi bi-arrow-clockwise"></i>
			{{ 'preConfigure.pageActions.reload' | translate }}
		</button>
		<button
				(click)="preConfigure()"
				[disabled]="!isContestConfirmed"
				class="btn btn-primary"
				type="button"
		>
			<i aria-hidden="true" class="bi bi-check-circle"></i>
			{{ 'preConfigure.pageActions.preConfigure' | translate }}
		</button>
	</ng-container>

	<!-- Pre-configuration in progress -->
	<ng-container *ngIf="configurationSummary" onProgress>
		<div class="spinner">
			<span aria-hidden="true" class="spinner-border"></span>
			<span
					class="visually-hidden"
					role="status"
			>{{ 'common.loading' | translate }}</span>
		</div>
		<p>
			{{ 'preConfigure.pageActions.inProgress' | translate }}
		</p>
	</ng-container>

	<!-- Loading summary error -->
	<ng-container *ngIf="!configurationSummary" onError>
		<p>
			{{ 'preConfigure.pageActions.error.LOADING_SUMMARY_ERROR' | translate }}
		</p>
		<button
				(click)="reload()"
				class="btn btn-primary"
				type="button"
		>
			<i aria-hidden="true" class="bi bi-arrow-clockwise"></i>
			{{ 'preConfigure.pageActions.reload' | translate }}
		</button>
	</ng-container>

	<!-- Pre-configuration error -->
	<ng-container *ngIf="configurationSummary" onError>
		<p *ngIf="!pageActionsComponent.hasErrorFeedback">
			{{ 'preConfigure.pageActions.error.default' | translate }}
		</p>
		<p *ngIf="pageActionsComponent.hasErrorFeedback">
			{{ 'preConfigure.pageActions.error.' + pageActionsComponent.errorFeedbackCode | translate }}
		</p>
	</ng-container>

	<!-- Pre-configuration complete -->
	<ng-container onComplete>
		<i aria-hidden="true" class="bi bi-check-circle"></i>
		<p>
			{{ 'preConfigure.pageActions.complete' | translate }}
		</p>
		<button class="btn btn-primary" sdmRouterLinkNext type="button">
			{{ 'common.next' | translate }}
			<i aria-hidden="true" class="bi bi-arrow-right-circle"></i>
		</button>
	</ng-container>
</sdm-page-actions>

<sdm-progress/>

<sdm-scrollbar>
	<sdm-configuration-summary [configurationSummary]="configurationSummary" *ngIf="configurationSummary"></sdm-configuration-summary>

		<div *ngIf="configurationSummary && workflowStatus !== WorkflowStatus.Complete" class="list-group mt-3">
		<div class="list-group-item list-group-item-info">
			<div class="form-check">
				<input
						[(ngModel)]="isContestConfirmed"
						class="form-check-input"
						id="validateSummary"
						type="checkbox"
						value=""
				/>
				<label class="form-check-label" for="validateSummary">
					{{ 'preConfigure.confirmation' | translate }}
				</label>
			</div>
		</div>
	</div>
</sdm-scrollbar>
